> ## Documentation Index
> Fetch the complete documentation index at: https://docs.magna.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Process Transactions

> Processes a list of signed transactions. Applicable for chains where the transaction is process by the dApp and not the wallet - e.g. Solana



## OpenAPI

````yaml /apis/portal/openapi.json post /api/v2/{portalId}/transaction/process
openapi: 3.0.2
info:
  title: Magna Portal API
  version: 1.0.0
servers: []
security: []
tags:
  - name: Auth
    description: Authentication related endpoints
  - name: Token
    description: Token claiming
  - name: Config
    description: Portal configuration
  - name: Misc
    description: Miscellaneous operational endpoints
  - name: Staking
    description: Staking pool operations
  - name: Compliance
    description: Wallet compliance operations
paths:
  /api/v2/{portalId}/transaction/process:
    post:
      tags:
        - Token
      summary: Process Transactions
      description: >-
        Processes a list of signed transactions. Applicable for chains where the
        transaction is process by the dApp and not the wallet - e.g. Solana
      parameters:
        - name: portalId
          in: path
          required: true
          schema:
            type: string
            format: uuid
          description: portal id
      requestBody:
        description: Body
        content:
          application/json:
            schema:
              type: object
              properties:
                signedTransactionsData:
                  type: array
                  items:
                    type: string
                  description: signed transaction data
                metadata:
                  discriminator:
                    propertyName: type
                  oneOf:
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - STAKE
                        stakeId:
                          type: string
                          format: uuid
                          description: stake id
                        poolId:
                          type: string
                          format: uuid
                          description: staking pool id
                        amount:
                          type: string
                          description: amount of tokens to stake
                      required:
                        - type
                        - stakeId
                        - poolId
                        - amount
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - CLAIM
                        distributionId:
                          type: string
                          format: uuid
                          description: distribution id
                      required:
                        - type
                        - distributionId
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - CLAIM_STAKE_REWARDS
                        stakeId:
                          type: string
                          format: uuid
                          description: stake id
                        poolId:
                          type: string
                          format: uuid
                          description: staking pool id
                        amount:
                          type: string
                          description: amount of tokens to claim
                      required:
                        - type
                        - stakeId
                        - poolId
                        - amount
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - UNSTAKE
                        stakeId:
                          type: string
                          format: uuid
                          description: stake id
                        poolId:
                          type: string
                          format: uuid
                          description: staking pool id
                        amount:
                          type: string
                          description: amount of tokens to unstake
                      required:
                        - type
                        - stakeId
                        - poolId
                        - amount
                    - type: object
                      properties:
                        type:
                          type: string
                          enum:
                            - STAKING_WITHDRAW
                        stakeId:
                          type: string
                          format: uuid
                          description: stake id
                        poolId:
                          type: string
                          format: uuid
                          description: staking pool id
                        amount:
                          type: string
                          description: amount of tokens to withdraw
                      required:
                        - type
                        - stakeId
                        - poolId
                        - amount
                  description: metadata for the transaction
              required:
                - signedTransactionsData
                - metadata
              example:
                value:
                  signedTransactionsData:
                    - >-
                      AS8TFuCAxBDePII5lTVMRFguyF2AqSyI5PBZjNYJLuWoVBG7aaq46QHHlQNamAw8VyxCDwbtv9jXI0IPgW7TCwkBAAMG5vXmqmwRqvfHYcS+ebPuAnB/wE0KjyR0VvnuINs3gJ5JqdqGW/mSy+aP+kmqobh5OxMDrD4B3gsZUdwvfygCyJxuNgcfEH9/LGqnusymkSRsyq16lbRm8uLtaLABK9qAAwZGb+UhFzL/7K26csOb57yM5bvF9xJrLEObOkAAAAAGgcTOR+IjaLixVV7Ih68JLvx++7Zso/Uvv2jUrJy3qAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAJ0v+16Lw4tg6V2PEQYuYz3OWsB1yf5p8tx5INsnPdcDAwAJA4rVAQAAAAAAAwAFAvLdAQAEBQECAAAF+AYw+k6o0OLa0wAAaQMAAAEBBg1/nC/sxJFVpgnbRGhYotrcjcBMFDKF8GX2Qp0o90ExUae9au3915vsCBiIRhbFcVaaJFtW9W2aK4X2yV3BjGTyZ+SO6+bD9ong/mm4mW0POcpMA5Io9nXExUPcBCCxaay9nCUaWTZGTD9TPr39zH0Bq5CoFBcR4uyGSZDdXe8sVu7J9koV9hDnZupuJA68a3GktivUtANq05bR1QDZM9u6qndFv6YyepsfCKJsEJpOhkhahbDfH904HhUMT0YJfFGd7zZ5RWxoqGLmBllBd/+B/It/Xk7qLEaLOaQnbrq9+Sxl38jUW9ApL74Ba5AoWqi+xc+U2xLDIdJV+Mkipy3IlvtwEHOvlUTKP19vpl5xdUZrpJuy+d/7G7kWqZxLI0gAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAbd9uHXZaGT2cvhRs7reawctIXtX1s3kTqM9YV+/wCpjJclj04kifG7PRApFI4NgwtaE5na/xCEBI572Nvp+FkGp9UXGSxcUSGMyUw9SvF/WNruCJuh/UTj29mKAAAAAAIHCgECCAADBAkKCwyVAYxGAWN7JEKh6vY9K7dk5+nHwlTjwIooTQmWeWW/EHLC7kzHGZPz5S1/nC/sxJFVpgnbRGhYotrcjcBMFDKF8GX2Qp0o90ExUZb7cBBzr5VEyj9fb6ZecXVGa6Sbsvnf+xu5FqmcSyNIgNdsLNADSgAAAAAAAAAAAAEBAAAA7sn2ShX2EOdm6m4kDrxrcaS2K9S0A2rTltHVANkz27ogAAAAZTUzNjJlNDkzYjQ5YjFhNGY4NzM3MTAyYmI0N2YzODkAAAAAAAAAAAoAAABgflFmAAAAAOBcemYAAAAA4OmhZgAAAABgyMpmAAAAAOCm82YAAAAA4DMbZwAAAABgEkRnAAAAAGCfa2cAAAAA4H2UZwAAAABgXL1nAAAAAAoAAADASHEEyGYHAMBIcQTIZgcAwEhxBMhmBwDASHEEyGYHAMBIcQTIZgcAwEhxBMhmBwDASHEEyGYHAMBIcQTIZgcAwEhxBMhmBwDASHEEyGYHACAAAABlNTM2MmU0OTNiNDliMWE0Zjg3MzcxMDJiYjQ3ZjM4OQcMAQIFBgADBAgJCgsMEAAGRgpwSjBk6YDXbCzQA0oAAAA=
                  metadata:
                    type: CLAIM
                    distributionId: d1c5b0f4-3b9c-4b9a-8a4d-7f8c2a1b2c3d
      responses:
        '200':
          description: Ok
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  properties:
                    hash:
                      type: string
                      nullable: true
                      description: hash of the transaction
                    errorMessage:
                      type: string
                      nullable: true
                      description: error messge
                  required:
                    - hash
                    - errorMessage
                description: Ok
                example:
                  - hash: >-
                      5Bedjdc7qNPwTUo4RPk6URPG3sQ2WNt9e2kNvQerbQ2THizACR7JhMjX2irRbLKyBot7ZMT3LEnKU62Pmp11xNyE
                    errorMessage: null
                  - hash: null
                    errorMessage: Transaction failed
        '400':
          description: Client Error
          content:
            application/json:
              schema:
                oneOf:
                  - type: object
                    properties:
                      errors:
                        type: array
                        items:
                          type: object
                          properties:
                            path:
                              type: string
                            message:
                              type: string
                          required:
                            - path
                            - message
                    required:
                      - errors
                  - type: object
                    properties:
                      error:
                        oneOf:
                          - type: string
                            enum:
                              - DISTRIBUTION_NOT_FOUND
                              - HUMANITY_CHECK_INCOMPLETE
                              - DISTRIBUTION_NOT_STARTED
                              - STAKING_POOL_NOT_FOUND
                              - STAKE_NOT_FOUND
                          - type: string
                    required:
                      - error
                description: Client Error
                example:
                  errors:
                    - path: query.wallet
                      message: Required
        '500':
          description: Server Error
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: string
                    description: error message
                required:
                  - error
                description: Server Error
                example:
                  error: internal server error

````